=== debian/changelog ===
libssh2 (1.11.1-1build1) questing; urgency=medium

  * Rebuild to include updated RISC-V base ISA RVA23

 -- Heinrich Schuchardt <heinrich.schuchardt@canonical.com>  Fri, 05 Sep 2025 19:40:07 +0000

libssh2 (1.11.1-1) unstable; urgency=medium

  [ Nicolas Mora ]
  * New upstream release
  * d/libssh2-1t64.symbols: Add new symbols
  * d/libssh2-1t64.lintian-overrides remove override file
  * d/patches: Disable all patches but
    0001-Add-lgpg-error-to-.pc-to-facilitate-static-linking.patch
    which is refreshed
  * d/tests: Add test to check that 'pkg-config --libs libssh2'
    does not return private libs

  [ Simon Josefsson ]
  * d/control: Drop unnecessary chrpath
  * d/tests/control: Drop unnecessary chrpath

 -- Nicolas Mora <babelouest@debian.org>  Wed, 16 Oct 2024 07:36:53 -0400
