=== debian/control ===
--- 
+++ 
@@ -6,7 +6,6 @@
              , debhelper-compat (= 13)
              , libssl-dev
              , zlib1g-dev
-             , chrpath
              , openssh-server <!nocheck>
 Standards-Version: 4.7.0
 Homepage: https://libssh2.org/
