=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export OPENSSH_NO_DOCKER = true

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

# openssl license issue has been fixed: #668271, #924937
#CONFIGURE_EXTRA_FLAGS += --with-libgcrypt --without-openssl
CONFIGURE_EXTRA_FLAGS += --libdir=\$${prefix}/lib/$(DEB_HOST_MULTIARCH)
CONFIGURE_EXTRA_FLAGS += --disable-rpath

%:
	dh $@ --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --disable-docker-tests \
											 $(CONFIGURE_EXTRA_FLAGS)

override_dh_installexamples:
	dh_installexamples -a -X .deps -X Makefile -X .gitignore

override_dh_installchangelogs:
	dh_installchangelogs NEWS

#
# mansyntax.sh test duplicates functionality of debhelper and requires presence
# of en_US.utf8 locale. Ensure it is not run by providing a fake man(1) tool.
#
override_dh_auto_test:
	PATH=$(CURDIR)/debian:$$PATH dh_auto_test -a
