=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.asc/ https://www.libssh2.org/download/libssh2-(.+)\.tar\.gz
